#include <string.h>
#define write1(s) write(1, s, strlen(s))
#include <gtk/gtk.h>

void leftclick(GtkStatusIcon *b, gpointer s){
	write1(s);	write1("\n");
}

void rightclick(GtkStatusIcon *status_icon, guint button,guint activate_time, gpointer s){
	write1(s);	write1("\n");
}


gboolean refresh(gpointer si){
	gtk_status_icon_set_from_file(si,gtk_status_icon_get_title(si));
}
 
int main(int argc, char *argv[]){
	GtkStatusIcon *si; int i=1,t;

if (argv[1][0]=='-'){ /* usage */
	write1("Usage:\n"
	" sit interval /pathto/image tooltip left-click-action right-click-action\n");
	return 1;
}

gtk_init (&argc, &argv);

while (i<argc) { /* loop through icon, tooltip, click messages */
	t=atoi(argv[i++]);
	si = gtk_status_icon_new_from_file(argv[i]);
	gtk_status_icon_set_title(si,argv[i++]);
	g_timeout_add(t, refresh,(gpointer) si);
	gtk_status_icon_set_tooltip_text(si,argv[i++]);
	g_signal_connect(G_OBJECT(si), "activate", G_CALLBACK(leftclick),(gpointer) argv[i++]);
	g_signal_connect(G_OBJECT(si), "popup-menu", G_CALLBACK(rightclick), (gpointer) argv[i++]);
}

gtk_main ();
}